function [focalLength1, focalLength2] = calcFocalLengthWithAnalysis(fmatrix)
  EPS=1.0e-6;


 'analysis method'
    tmp1 = dot(vectorK , fMatrix * vectorK);
    tmp2 = norm(fMatrix' * vectorK )^2;
    tmp3 = norm(fMatrix * vectorK )^2;
    tmp4 = norm(fMatrix , 'fro')^2;
    tmp5 = norm(fMatrix * fMatrix' * vectorK )^2;
    tmp6 = norm(fMatrix' * fMatrix * vectorK )^2;
   
    
    a1 = 0.5 * tmp1^4 ;
    a2 = tmp1^2 * ( tmp2 + tmp3 );
    a3 = 0.5 * ( tmp2 - tmp3 )^2  + tmp1 * ( 4 * dot(vectorK , fMatrix * fMatrix' * fMatrix * vectorK) - tmp1 * tmp4);
    a4 = 2 * ( tmp5 + tmp6 ) - ( tmp2 + tmp3 ) * tmp4;
    
    a5 = norm(fMatrix * fMatrix' , 'fro')^2 - 0.5 * norm(fMatrix , 'fro')^4;%
    
if abs(a1) >= EPS, 
    %% cubic equation
    'cubic equation'
    % cubic equation descriminant

else if abs(a2) >= EPS,
         %% quadratic equation %%
         'quadratic eqaution'

         % quadratic descriminant %        
         D = 4 * a3 * a3 - 12 * a2 * a4; 
         if D >= 0, 
             x = (-2 * a3 + sqrt(D)) / (6 * a2);             
         else
             x = 0;
         end

     else
         if abs(a3) >= EPS,
              %% linear equation %%
              'linear equation'
             
               x = - a4 / (2 * a3); % x = -a4 / (2a3)
              
         else
              %% x == 0 %%
               x = 0;
         end         
     end
end

if -1 < x, 
   f1 = focal_base / (sqrt(1+x));
else
   disp('Warning!! x is less than 0. f1 = f2 = f0 ')
   f1 = focal_base;  
end

f2 = f1;
