function vectorU = initializeWithTaubin(pairList , len , focus_base)
f = focus_base;
matrixLS = zeros(9 , 9);

vectorZees = cell(1 , len);
matrixVs = cell(1 , len);
sumOfVectorZees = 0;

for i = 1 : len
    pair = pairList{i , 1};
    x1 = pair{1} ;
    y1 = pair{2} ;
    x2 = pair{3} ;
    y2 = pair{4} ;
    
    vectorZees{i} = [ x1 * x2 ;
                      x1 * y2 ;
                      f * x1 ;
                      y1 * x2 ;
                      y1 * y2 ;
                      f * y1 ;
                      f * x2 ;
                      f * y2 ];
                  
    sumOfVectorZees = sumOfVectorZees + vectorZees{i};
             
    matrixVs{i} = [ x1^2 + x2^2 , x2 * y2     , f * x2 , x1 * y1     , 0           , 0      , f * x1 , 0      ;
                    x2 * y2     , x1^2 + y2^2 , f * y2 , 0           , x1 * y1     , 0      , 0      , f * x1 ;
                    f * x2      , f * y2      , f * f  , 0           , 0           , 0      , 0      , 0      ;
                    x1 * y1     , 0           , 0      , y1^2 + x2^2 , x2 * y2     , f * x2 , f * y1 , 0      ;
                    0           , x1 * y1     , 0      , x2 * y2     , y1^2 + y2^2 , f * y2 , 0      , f * y1 ;
                    0           , 0           , 0      , f * x2      , f * y2      , f * f  , 0      , 0      ;
                    f * x1      , 0           , 0      , f * y1      , 0           , 0      , f * f  , 0      ;
                    0           , f * x1      , 0      , 0           , f * y1      , 0      , 0      , f * f  ];
end

vectorZeeTopBar = sumOfVectorZees / len % the average of vectorZees;
vectorZeeTildes = cell(1 , len);
matrixMTB = zeros(8 , 8);
matrixLTB = zeros(8 , 8);

for i = 1 : len
    vectorZeeTildes{i} = vectorZees{i} - vectorZeeTopBar;

    matrixMTB = matrixMTB + vectorZeeTildes{i} * vectorZeeTildes{i}';
    matrixLTB = matrixLTB + matrixVs{i};
end

% solve generalized-engenvalue problem

[V , D] = eig(matrixMTB , matrixLTB);

min = D(1 , 1);
eigenVector = V(: ,1);
for i = 1 : 8
    if D( i , i) < min ,
        min = D( i , i);
        eigenVector = V(: , i);
    end
end

eigenVector;
vectorU = [ eigenVector ;
            -dot(eigenVector , vectorZeeTopBar) / (f * f)];
            
        


