function x = judgeFocalGaze(fMatrix, MAX_LOOP_NUMBER)
    global EPSILON    
    vectorK = [0; 0; 1];    
    'gaze'
    tmp1 = dot(vectorK , fMatrix * vectorK);
    tmp2 = norm(fMatrix' * vectorK )^2;
    tmp3 = norm(fMatrix * vectorK )^2;
    tmp4 = norm(fMatrix , 'fro')^2;
    tmp5 = norm(fMatrix * fMatrix' * vectorK )^2;
    tmp6 = norm(fMatrix' * fMatrix * vectorK )^2;
    
    
    a1 = 0.5 * tmp1^4;
    a2 = tmp1^2 * ( tmp2 + tmp3 );
    a3 = 0.5 * ( tmp2 - tmp3 )^2  + tmp1 * ( 4 * dot(vectorK , fMatrix * fMatrix' * fMatrix * vectorK) - tmp1 * tmp4);
    a4 = 2 * ( tmp5 + tmp6 ) - ( tmp2 + tmp3 ) * tmp4;
    
    a5 = norm(fMatrix * fMatrix' , 'fro')^2 - 0.5 * norm(fMatrix , 'fro')^4;
    
    x = - a4 / (2 * a3);
    

    while 1         % Newton Method's begin
        count = 0;  % loop counter
        
        %% repeat until x is convergenced. 
        while 1
            
            %% K(x) definition.
            k1 = 4 * a1 * x^3 + 3 * a2 * x^2 + 2 * a3 * x + a4;
            k2 = 12 * a1 * x^2 + 6 * a2 * x + 2 * a3;
            
            %% update value.
            deltaX = k1 / k2;
            
            % x <== max(-1, x-K1/K2)
            if -1 < (x - deltaX),
                xPrime = x - deltaX;
            else
                xPrime = -1;
            end
            xPrime
        
            % check Newton Method(NM) convergence.
            if abs(xPrime - x) < EPSILON , break; end
            
            % if NM is not convergenced, x = x\prime and count++ 
            x = xPrime;
            count = count + 1;
            
            % check count value is exceed max loop number. 
            if count == MAX_LOOP_NUMBER ,
                disp('max loop count exceeded')
                error('max loop count exceeded')
            end
        end % inner while's end(NM is convergenced normally.)
        
        
        %% check x. If x is -1, change not Gaze method.
        if x == -1.00000000000 , 
            disp('x is -1. So change the not Gaze method.')
            error('x is -1')
            
        else
            % if x is not -1, check K2.
            k2 = 12 * a1 * x^2 + 6 * a2 * x + 2 * a3;
            
            % if K2 is greater than 0, calculating is end. K2 is
            % less than or equal to 0, update K2 by incresing x value.
            
            if (k2 > 0)
                break;
            else
                h = 0.005;
                while (k2 <= 0)
                    h = h * 2;
                    x = x + h;
                    k2 = 12 * a1 * x^2 + 6 * a2 * x + 2 * a3;
                
                end
            end
        end
    end         % Newton Method's while end
    