function [vectorU , pairList , pairListHat , pairListTilde] = update(vectorU  , pairList , pairListHat , pairListTilde, len , focus_base, updateFundamental)

f = focus_base;
vectorXis = cell(1 , len);
matrixVs= cell(1 , len);

for i = 1 : len
    pair = pairListHat{i};
    xh1 = pair{1};
    yh1 = pair{2};
    xh2 = pair{3};
    yh2 = pair{4};
    
    pair = pairListTilde{i};
    xt1 = pair{1};
    yt1 = pair{2};
    xt2 = pair{3};
    yt2 = pair{4};
    

    vectorXis{i} = [ xh1 * xh2 + xh2 * xt1 + xh1 * xt2 ;
                     xh1 * yh2 + yh2 * xt1 + xh1 * yt2 ;
                     f * ( xh1 + xt1)                  ;
                     yh1 * xh2 + xh2 * yt1 + yh1 * xt2 ;
                     yh1 * yh2 + yh2 * yt1 + yh1 * yt2 ;
                     f * ( yh1 + yt1)                  ;
                     f * ( xh2 + xt2)                  ;
                     f * ( yh2 + yt2)                  ;
                     f * f                              ];
                  
             
    matrixVs{i} = [ xh1^2 + xh2^2 , xh2 * yh2     , f * xh2 , xh1 * yh1     , 0             , 0       , f * xh1 , 0       , 0;
                    xh2 * yh2     , xh1^2 + yh2^2 , f * yh2 , 0             , xh1 * yh1     , 0       , 0       , f * xh1 , 0;
                    f * xh2       , f * yh2       , f * f   , 0             , 0             , 0       , 0       , 0       , 0;
                    xh1 * yh1     , 0             , 0       , yh1^2 + xh2^2 , xh2 * yh2     , f * xh2 , f * yh1 , 0       , 0;
                    0             , xh1 * yh1     , 0       , xh2 * yh2     , yh1^2 + yh2^2 , f * yh2 , 0       , f * yh1 , 0;
                    0             , 0             , 0       , f * xh2       , f * yh2       , f * f   , 0       , 0       , 0;
                    f * xh1       , 0             , 0       , f * yh1       , 0             , 0       , f * f   , 0       , 0;
                    0             , f * xh1       , 0       , 0             , f * yh1       , 0       , 0       , f * f   , 0;
                    0             , 0             , 0       , 0             , 0             , 0       , 0       , 0       , 0];
                
end

% 基礎行列の更新を行うか否か
if strcmpi(updateFundamental, 'update')
  vectorU = efns(vectorU , vectorXis , matrixVs ,  len );
end

% update tilde variables
for i = 1 : len
    pair = pairListHat{i};
    xh1 = pair{1};
    yh1 = pair{2};
    xh2 = pair{3};
    yh2 = pair{4};
   
    
    pair = pairList{i};
    x1 = pair{1};
    y1 = pair{2};
    x2 = pair{3};
    y2 = pair{4};
   
    constantTmp = dot(vectorU , vectorXis{i}) / dot(vectorU , matrixVs{i} * vectorU);
    vectorTmp = [xh2 ; yh2 ; f];

    matrixTmp = [ vectorU(1) , vectorU(2) , vectorU(3) ;
                  vectorU(4) , vectorU(5) , vectorU(6) ];

    newPosition = constantTmp * matrixTmp * vectorTmp;
    xt1 = newPosition(1);
    yt1 = newPosition(2);
    
    
   
    vectorTmp = [xh1 ; yh1 ; f];

    matrixTmp = [ vectorU(1) , vectorU(4) , vectorU(7) ;
                  vectorU(2) , vectorU(5) , vectorU(8) ];

    newPosition = constantTmp * matrixTmp * vectorTmp;
    xt2 = newPosition(1);
    yt2 = newPosition(2);
    
    xh1 = x1 - xt1;
    yh1 = y1 - yt1;
    xh2 = x2 - xt2;
    yh2 = y2 - yt2;
   
    
    pairListHat{i}{1} = xh1;
    pairListHat{i}{2} = yh1;
    pairListHat{i}{3} = xh2;
    pairListHat{i}{4} = yh2;
    
    pairListTilde{i}{1} = xt1;
    pairListTilde{i}{2} = yt1;
    pairListTilde{i}{3} = xt2;
    pairListTilde{i}{4} = yt2;
    
end



